<template>
  <div class="content" id="content" :class="!selectedRoom ? 'empty' : '' " ref="contentfeed">
    <div class="container">
      <div class="col-md-12" v-viewer>
        <!-- <div class="date">
          <hr>
          <span>Yesterday</span>
          <hr>
        </div>-->
        <template v-if="!selectedRoom">
          <div class="no-messages">
            <img :src="asset('images/icons/img_no_chat_yet.png')" class="img-fluid">
            <h4 class="mt-2 text-muted">No active chats yet.</h4>
            <span class="d-block text-muted">Its looks like no one's said Hi!</span>
            <span class="d-block text-muted">Why don't you get the conversation going?</span>
          </div>
        </template>
        <template v-else>
          <!-- <div class="test" ref="feed"> -->
          <infinite-loading
            direction="top"
            @infinite="infiniteHandler"
            :identifier="selectedRoom"
            v-show="selectedRoom.messages.length > 0"
          >
            <div slot="no-more">
              <span class="badge badge-primary p-1">This is the first message</span>
            </div>
            <div slot="no-results">
              <span class="badge badge-primary p-1">This is the first message</span>
            </div>
          </infinite-loading>
          <div v-for="message in selectedRoom.messages" :key="message.id" class="mb-3">
            <template v-for="(content,key) in message.content">
              <component
                :is="'type-'+content.type"
                :content="content"
                :message="message"
                :isSent="checkisSent(message)"
                :key="key"
              ></component>
            </template>

            <!-- <small class="text-muted d-block py-0" style="padding-left:60px" :class="{'text-right':checkisSent(message)}">{{formatDate(message.created_at,"LT")}}</small> -->
          </div>
          <!-- </div> -->
        </template>
      </div>
    </div>
  </div>
</template>

<script>
import TypeText from "./messagetype/Text";
import TypeCarousel from "./messagetype/Carousel";
import TypeImage from "./messagetype/Image";
import TypeConfirm from "./messagetype/Confirm";
import TypeSummary from "./messagetype/Summary";
import TypeTyping from "./messagetype/Typing";
import TypeAudio from "./messagetype/Audio";
import TypeVideo from "./messagetype/Video";
import TypeFile from "./messagetype/File";
import TypeLocation from "./messagetype/Location";
import TypeHtml from "./messagetype/Html";
import TypeGrid from "./messagetype/Grid";
import TypeWeather from "./messagetype/Weather";
import chatMixin from "@/mixins/ChatMixin";
import InfiniteLoading from "vue-infinite-loading";
import EventBus from "@/EventBus.js";

export default {
  mixins: [chatMixin],
  data() {
    return {};
  },
  computed: {
    async chatFeeds() {
      return await this.$store.getters["chat/chatFeeds"];
    },
    selectedRoom() {
      return this.$store.getters["chat/selectedRoom"];
    }
  },
  components: {
    "type-text": TypeText,
    "type-carousel": TypeCarousel,
    "type-image": TypeImage,
    "type-confirm": TypeConfirm,
    "type-summary": TypeSummary,
    "type-typing": TypeTyping,
    "type-audio": TypeAudio,
    "type-video": TypeVideo,
    "type-file": TypeFile,
    "type-location": TypeLocation,
    "type-html": TypeHtml,
    "type-grid": TypeGrid,
    "type-weather": TypeWeather,
    "infinite-loading": InfiniteLoading
  },
  methods: {
    infiniteHandler($state) {
      this.$axiosNoLoading
        .post(
          `api/${this.$store.getters.appId.hashed}/message/get-more-message`,
          {
            roomId: this.selectedRoom.id,
            firstMessageId: _.head(this.selectedRoom.messages).id
          }
        )
        .then(response => {
          response = response.data;

          if (response.data.messages.length > 0) {
            this.$store.dispatch("chat/handleInfiniteScroll", {
              messages: response.data.messages
            });
            $state.loaded();
          } else {
            $state.complete();
          }
        });
    },
    scrollToBottom() {
      setTimeout(() => {
        this.$refs.contentfeed.scrollTop = this.$refs.contentfeed.scrollHeight;
      }, 10);
    },
    checkisSent(message) {
      return (
        message.messageable_id ==
          this.$store.getters.localStorage.decodedUserId &&
        message.messageable_type == "user_platform"
      );
    }
  },

  watch: {
    "selectedRoom.messages": function(newVal, oldVal) {
      if (_.isUndefined(oldVal)) {
        this.scrollToBottom();
      } else if (_.head(oldVal).id == _.head(newVal).id) {
        this.scrollToBottom();
      }
    },
    selectedRoom: function(newVal, oldVal) {
      this.scrollToBottom();
    }
  },
  mounted() {}
};
</script>

<style scoped>
.content {
  background: #fdfdfd;
  /* max-height:calc(100vh - 240px); */
  max-height: 70vh;

  /* padding: 10px 0 !important;
  height: 100vh !important; */
}
.test {
  height: 200px;
  overflow-y: scroll;
}
</style>
